--- src/backend/access/index/indexam.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/index/indexam.c	2014-08-19 16:56:13.855197774 -0400
@@ -79,6 +79,55 @@
 #include "utils/tqual.h"
 
 
+#ifdef USE_PREFETCH
+bool BlocknotinBuffer(Buffer buffer, Relation relation, BlockNumber blockNum);
+BlockNumber BlocknumOfBuffer(Buffer buffer);
+void index_mark_or_evict_block(IndexScanDesc scan , BlockNumber blocknumber , int markit);
+
+extern unsigned int prefetch_index_scans; /*  boolean whether to prefetch bitmap heap scans         */
+
+/*  if specified block number is present in the prefetch array,
+**  then either mark it as not to be discarded or evict it according to input param
+*/
+void index_mark_or_evict_block(IndexScanDesc scan , BlockNumber blocknumber , int markit)
+{
+        unsigned short int pfchx , pfchy , pfchz; /*  indexes in BlockIdData array   */
+
+        if (    scan->do_prefetch
+             && ((struct pfch_block_item*)0 != scan->pfch_block_item_list)
+             /* no need to check for scan->pfch_next < prefetch_index_scans
+             ** since we will do nothing if scan->pfch_used == 0
+             */
+           ) {
+            /*  search the prefetch list to find if the block is a member */
+            for (pfchx = 0; pfchx < scan->pfch_used; pfchx++) {
+                if (BlockIdGetBlockNumber(&(((scan->pfch_block_item_list)+pfchx)->pfch_blockid)) == blocknumber) {
+                      if (markit) {
+						      /*  mark it as not to be discarded */
+						      ((scan->pfch_block_item_list)+pfchx)->pfch_discard &= ~PREFTCHRC_BUF_PIN_INCREASED;
+					  } else {
+							  /*  shuffle all following the evictee to the left
+							  **  and update next pointer if its element moves
+							  */
+							  pfchy = (scan->pfch_used - 1); /*  current rightmost */
+							  scan->pfch_used = pfchy;
+
+							  while (pfchy > pfchx) {
+								  pfchz = pfchx + 1;
+								  BlockIdCopy((&(((scan->pfch_block_item_list)+pfchx)->pfch_blockid)), (&(((scan->pfch_block_item_list)+pfchz)->pfch_blockid)));
+								  ((scan->pfch_block_item_list)+pfchx)->pfch_discard = ((scan->pfch_block_item_list)+pfchz)->pfch_discard;
+								  if (scan->pfch_next == pfchz) {
+									  scan->pfch_next = pfchx;
+								  }
+								  pfchx = pfchz; /* advance */
+							  }
+                      }
+                }
+            }
+        }
+}
+#endif /* USE_PREFETCH */
+
 /* ----------------------------------------------------------------
  *					macros used in index_ routines
  *
@@ -253,6 +302,11 @@ index_beginscan(Relation heapRelation,
 	 */
 	scan->heapRelation = heapRelation;
 	scan->xs_snapshot = snapshot;
+#ifdef USE_PREFETCH
+	scan->do_prefetch = 0;             /*  no prefetching by default  */
+        scan->pfch_index_page_list = (struct pfch_index_pagelist*)0;
+	scan->pfch_block_item_list = (struct pfch_block_item*)0;
+#endif   /* USE_PREFETCH */
 
 	return scan;
 }
@@ -277,6 +331,11 @@ index_beginscan_bitmap(Relation indexRel
 	 * up by RelationGetIndexScan.
 	 */
 	scan->xs_snapshot = snapshot;
+#ifdef USE_PREFETCH
+	scan->do_prefetch = 0;             /*  no prefetching by default  */
+        scan->pfch_index_page_list = (struct pfch_index_pagelist*)0;
+	scan->pfch_block_item_list = (struct pfch_block_item*)0;
+#endif   /* USE_PREFETCH */
 
 	return scan;
 }
@@ -311,6 +370,9 @@ index_beginscan_internal(Relation indexR
 									  Int32GetDatum(nkeys),
 									  Int32GetDatum(norderbys)));
 
+	scan->heap_tids_seen = 0;
+	scan->heap_tids_fetched = 0;
+	
 	return scan;
 }
 
@@ -342,6 +404,12 @@ index_rescan(IndexScanDesc scan,
 	/* Release any held pin on a heap page */
 	if (BufferIsValid(scan->xs_cbuf))
 	{
+#ifdef USE_PREFETCH
+                /*   if specified block number is present in the prefetch array,  then evict it */
+                if (scan->do_prefetch) {
+                      index_mark_or_evict_block(scan , BlocknumOfBuffer(scan->xs_cbuf) , 0);
+                }
+#endif   /* USE_PREFETCH */
 		ReleaseBuffer(scan->xs_cbuf);
 		scan->xs_cbuf = InvalidBuffer;
 	}
@@ -373,10 +441,30 @@ index_endscan(IndexScanDesc scan)
 	/* Release any held pin on a heap page */
 	if (BufferIsValid(scan->xs_cbuf))
 	{
+#ifdef USE_PREFETCH
+                /*   if specified block number is present in the prefetch array,  then evict it */
+                if (scan->do_prefetch) {
+                      index_mark_or_evict_block(scan , BlocknumOfBuffer(scan->xs_cbuf) , 0);
+                }
+#endif   /* USE_PREFETCH */
 		ReleaseBuffer(scan->xs_cbuf);
 		scan->xs_cbuf = InvalidBuffer;
 	}
 
+#ifdef USE_PREFETCH
+        /*   discard prefetched but unread buffers */
+        if (    scan->do_prefetch
+             && ((struct pfch_block_item*)0 != scan->pfch_block_item_list)
+           ) {
+            unsigned short int pfchx; /*  index in BlockIdData array   */
+                for (pfchx = 0; pfchx < scan->pfch_used; pfchx++) {
+                  if (((scan->pfch_block_item_list)+pfchx)->pfch_discard) {
+                      DiscardBuffer(scan->heapRelation, MAIN_FORKNUM, BlockIdGetBlockNumber(&(((scan->pfch_block_item_list)+pfchx)->pfch_blockid)));
+                  }
+                }
+        }
+#endif   /* USE_PREFETCH */
+
 	/* End the AM's scan */
 	FunctionCall1(procedure, PointerGetDatum(scan));
 
@@ -472,6 +560,12 @@ index_getnext_tid(IndexScanDesc scan, Sc
 		/* ... but first, release any held pin on a heap page */
 		if (BufferIsValid(scan->xs_cbuf))
 		{
+#ifdef USE_PREFETCH
+                    /*   if specified block number is present in the prefetch array,  then evict it */
+                    if (scan->do_prefetch) {
+                          index_mark_or_evict_block(scan , BlocknumOfBuffer(scan->xs_cbuf) , 0);
+                    }
+#endif   /* USE_PREFETCH */
 			ReleaseBuffer(scan->xs_cbuf);
 			scan->xs_cbuf = InvalidBuffer;
 		}
@@ -479,6 +573,11 @@ index_getnext_tid(IndexScanDesc scan, Sc
 	}
 
 	pgstat_count_index_tuples(scan->indexRelation, 1);
+	if (scan->heap_tids_seen++ >= (~0)) {
+		/* Avoid integer overflow */
+		scan->heap_tids_seen = 1;
+		scan->heap_tids_fetched = 0;
+	}
 
 	/* Return the TID of the tuple we found. */
 	return &scan->xs_ctup.t_self;
@@ -502,6 +601,10 @@ index_getnext_tid(IndexScanDesc scan, Sc
  * enough information to do it efficiently in the general case.
  * ----------------
  */
+#if defined(USE_PREFETCH) && defined(AVOID_CATALOG_MIGRATION_FOR_ASYNCIO)
+extern Datum btpeeknexttuple(IndexScanDesc scan);
+#endif /* USE_PREFETCH */
+
 HeapTuple
 index_fetch_heap(IndexScanDesc scan)
 {
@@ -509,16 +612,111 @@ index_fetch_heap(IndexScanDesc scan)
 	bool		all_dead = false;
 	bool		got_heap_tuple;
 
+
+
 	/* We can skip the buffer-switching logic if we're in mid-HOT chain. */
 	if (!scan->xs_continue_hot)
 	{
 		/* Switch to correct buffer if we don't have it already */
 		Buffer		prev_buf = scan->xs_cbuf;
 
+#ifdef USE_PREFETCH
+
+                /*   If the old block is different from new block, then evict old
+                **   block from prefetched array.   It is arguable we should leave it
+                **   in the array because it's likely to remain in the buffer pool
+                **   for a while,  but in that case , if we encounter the block
+                **   again,  prefetching it again does no harm.
+                **   (and note that,  if it's not pinned,  prefetching it will try to
+                **   pin it since prefetch tries to bank a pin for a buffer in the buffer pool).
+                **   therefore it should usually win.
+                */
+                if (    scan->do_prefetch
+                     && ( BufferIsValid(prev_buf) )
+                     && (BlocknotinBuffer(prev_buf,scan->heapRelation,ItemPointerGetBlockNumber(tid)))
+                     && (scan->pfch_next < prefetch_index_scans)  /* ensure there is an entry */
+                        ) {
+                          index_mark_or_evict_block(scan , BlocknumOfBuffer(prev_buf) , 0);
+                }
+
+#endif   /* USE_PREFETCH  */
 		scan->xs_cbuf = ReleaseAndReadBuffer(scan->xs_cbuf,
 											 scan->heapRelation,
 											 ItemPointerGetBlockNumber(tid));
 
+#ifdef USE_PREFETCH
+                /*   If the new block had been prefetched and pinned,
+                **   then mark that it no longer requires to be discarded.
+                **   Of course,  we don't evict the entry,
+                **   because we want to remember that it was recently prefetched.
+                */
+                index_mark_or_evict_block(scan , BlocknumOfBuffer(prev_buf) , 1);
+#endif   /* USE_PREFETCH  */
+
+				scan->heap_tids_fetched++;
+
+#ifdef USE_PREFETCH
+                /*  try prefetching next data block
+                **    (next meaning one containing TIDs from matching keys
+                **     in same index page and different from any block
+                **     we previously prefetched and listed in prefetched array)
+                */
+                {
+                    FmgrInfo   *procedure;
+                    bool	found;             /*  did we find the "next" heap tid in current index page */
+                    int         PrefetchBufferRc;  /*  indicates whether requested prefetch block already in a buffer and if pin count on buffer has been increased */
+
+                    if (scan->do_prefetch) {
+#ifdef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+                        procedure = &scan->indexRelation->rd_aminfo->ampeeknexttuple; /* is incorrect but avoids adding function to catalog */
+#else /*  not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+                        if (RegProcedureIsValid(scan->indexRelation->rd_am->ampeeknexttuple)) {
+                            GET_SCAN_PROCEDURE(ampeeknexttuple); /* is correct but requires adding function to catalog */
+                        } else {
+                            procedure = 0;
+                        }
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+
+                        if (    procedure          /* does the index access method support peektuple? */
+#ifndef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+                             && procedure->fn_addr /* procedure->fn_addr is non-null only if in catalog */
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+                           ) {
+                            int iterations = 1;      /*  how many iterations of prefetching shall we try  -
+                                                     **  if used entries in prefetch list is < target_prefetch_pages
+                                                     **  then 2,  else 1
+                                                     **  this should result in gradually and smoothly increasing up to target_prefetch_pages
+                                                     */
+                            /*  note we trust InitIndexScan verified this scan is forwards only and so set that */
+                            if (scan->pfch_used < target_prefetch_pages) {
+                                iterations = 2;
+                            }
+                            do {
+                                found =  DatumGetBool(
+#ifdef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+                                                         btpeeknexttuple(scan)     /*  pass scan as direct parameter since cant use fmgr because not in catalog */
+#else /*  not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+                                                         FunctionCall1(procedure, PointerGetDatum(scan)) /* use fmgr to call it because in catalog  */
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+                                                     );
+                                if (found) {
+                                    /*    btpeeknexttuple set pfch_next to point to the item in block_item_list to be prefetched */
+                                    PrefetchBufferRc = PrefetchBuffer(scan->heapRelation, MAIN_FORKNUM, BlockIdGetBlockNumber((&((scan->pfch_block_item_list + scan->pfch_next))->pfch_blockid)) , 0);
+                                    /* elog(LOG,"index_fetch_heap prefetched rel %u blockNum %u"
+                                       ,scan->heapRelation->rd_node.relNode ,BlockIdGetBlockNumber(scan->pfch_block_item_list + scan->pfch_next));
+                                    */
+
+                                    /*  if pin acquired on buffer,  then remember in case of future Discard */
+                                    (scan->pfch_block_item_list + scan->pfch_next)->pfch_discard = (PrefetchBufferRc & PREFTCHRC_BUF_PIN_INCREASED);
+
+
+                                }
+                            } while (--iterations > 0);
+                        }
+                    }
+                }
+#endif   /* USE_PREFETCH */
+
 		/*
 		 * Prune page, but only if we weren't already on this page
 		 */
--- src/backend/access/index/genam.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/index/genam.c	2014-08-19 16:56:13.883197874 -0400
@@ -77,6 +77,12 @@ RelationGetIndexScan(Relation indexRelat
 
 	scan = (IndexScanDesc) palloc(sizeof(IndexScanDescData));
 
+#ifdef USE_PREFETCH
+        scan->do_prefetch = 0;             /*  no prefetching by default  */
+        scan->pfch_index_page_list = (struct pfch_index_pagelist*)0;
+        scan->pfch_block_item_list = (struct pfch_block_item*)0;
+#endif   /* USE_PREFETCH */
+
 	scan->heapRelation = NULL;	/* may be set later */
 	scan->indexRelation = indexRelation;
 	scan->xs_snapshot = InvalidSnapshot;		/* caller must initialize this */
@@ -139,6 +145,19 @@ RelationGetIndexScan(Relation indexRelat
 void
 IndexScanEnd(IndexScanDesc scan)
 {
+#ifdef USE_PREFETCH
+	if (scan->do_prefetch) {
+		if ( (struct pfch_block_item*)0 != scan->pfch_block_item_list ) {
+			pfree(scan->pfch_block_item_list);
+			scan->pfch_block_item_list = (struct pfch_block_item*)0;
+		}
+		if ( (struct pfch_index_pagelist*)0 != scan->pfch_index_page_list ) {
+			pfree(scan->pfch_index_page_list);
+			scan->pfch_index_page_list = (struct pfch_index_pagelist*)0;
+		}
+	}
+#endif   /* USE_PREFETCH */
+
 	if (scan->keyData != NULL)
 		pfree(scan->keyData);
 	if (scan->orderByData != NULL)
--- src/backend/access/nbtree/nbtsearch.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/nbtree/nbtsearch.c	2014-08-19 16:56:13.911197974 -0400
@@ -23,13 +23,18 @@
 #include "utils/lsyscache.h"
 #include "utils/rel.h"
 
+#ifdef USE_PREFETCH
+extern unsigned int prefetch_btree_heaps;  /*  boolean whether to prefetch heap pages in _bt_next for non-bitmap index scans   */
+extern unsigned int prefetch_sequential_index_scans;  /*  boolean whether to prefetch sequential-access non-bitmap index scans  */
+#endif   /* USE_PREFETCH */
 
 static bool _bt_readpage(IndexScanDesc scan, ScanDirection dir,
 			 OffsetNumber offnum);
 static void _bt_saveitem(BTScanOpaque so, int itemIndex,
 			 OffsetNumber offnum, IndexTuple itup);
-static bool _bt_steppage(IndexScanDesc scan, ScanDirection dir);
-static Buffer _bt_walk_left(Relation rel, Buffer buf);
+static bool _bt_steppage(IndexScanDesc scan, ScanDirection dir, 
+			 bool prefetch);
+static Buffer _bt_walk_left(IndexScanDesc scan, Relation rel, Buffer buf);
 static bool _bt_endpoint(IndexScanDesc scan, ScanDirection dir);
 
 
@@ -226,7 +231,11 @@ _bt_moveright(Relation rel,
 				_bt_relbuf(rel, buf);
 
 			/* re-acquire the lock in the right mode, and re-check */
-			buf = _bt_getbuf(rel, blkno, access);
+			buf = _bt_getbuf(rel, blkno, access
+#ifdef USE_PREFETCH
+                                     , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                        );
 			continue;
 		}
 
@@ -1005,7 +1014,7 @@ _bt_first(IndexScanDesc scan, ScanDirect
 		 * There's no actually-matching data on this page.  Try to advance to
 		 * the next page.  Return false if there's no matching data at all.
 		 */
-		if (!_bt_steppage(scan, dir))
+		if (!_bt_steppage(scan, dir, false))
 			return false;
 	}
 
@@ -1040,6 +1049,8 @@ _bt_next(IndexScanDesc scan, ScanDirecti
 {
 	BTScanOpaque so = (BTScanOpaque) scan->opaque;
 	BTScanPosItem *currItem;
+	BlockNumber prevblkno = ItemPointerGetBlockNumber(
+		&scan->xs_ctup.t_self);
 
 	/*
 	 * Advance to next tuple on current page; or if there's no more, try to
@@ -1052,11 +1063,56 @@ _bt_next(IndexScanDesc scan, ScanDirecti
 			/* We must acquire lock before applying _bt_steppage */
 			Assert(BufferIsValid(so->currPos.buf));
 			LockBuffer(so->currPos.buf, BT_READ);
-			if (!_bt_steppage(scan, dir))
+			if (!_bt_steppage(scan, dir, target_prefetch_pages > 0))
 				return false;
 			/* Drop the lock, but not pin, on the new page */
 			LockBuffer(so->currPos.buf, BUFFER_LOCK_UNLOCK);
 		}
+		
+#ifdef USE_PREFETCH
+                /*    consider prefetching */
+		if (prefetch_btree_heaps && (target_prefetch_pages > 0)) {
+			BlockNumber currblkno = ItemPointerGetBlockNumber(
+				&so->currPos.items[so->currPos.itemIndex].heapTid);
+		
+			if (currblkno != prevblkno) {
+				if (so->prefetchBlockCount > 0)
+					so->prefetchBlockCount--;
+			
+				/* If we have heap fetch frequency stats, and it's above ~94%,
+				 * initiate heap prefetches */
+				if (so->currPos.moreRight
+					&& scan->heap_tids_seen > 256 
+					&& ( (scan->heap_tids_seen - scan->heap_tids_seen/16)
+						 <= scan->heap_tids_fetched ) )
+				{
+					bool nonsequential = false;
+				
+					if (so->prefetchItemIndex <= so->currPos.itemIndex)
+						so->prefetchItemIndex = so->currPos.itemIndex + 1;
+					while (    (so->prefetchItemIndex <= so->currPos.lastItem)
+							&& (so->prefetchBlockCount < target_prefetch_pages) )
+					{
+						ItemPointer tid = &so->currPos.items[so->prefetchItemIndex++].heapTid;
+						BlockNumber blkno = ItemPointerGetBlockNumber(tid);
+						if (blkno != so->lastHeapPrefetchBlkno) {  /*  if not a repetition of previous block */
+							/*   start prefetch on next page, providing :
+                            **   EITHER  .  we're reading non-sequentially previously or for this block
+                            **   OR      .  user explicitly specified to prefetch for sequential pattern
+							**   as it may be counterproductive otherwise
+                            */
+							nonsequential = (nonsequential || blkno != (so->lastHeapPrefetchBlkno+1));
+							if (prefetch_sequential_index_scans || nonsequential) {
+								_bt_prefetchbuf(scan->heapRelation, blkno , &scan->pfch_index_page_list );
+							}
+							so->lastHeapPrefetchBlkno = blkno;
+							so->prefetchBlockCount++;
+						}
+					}
+				}
+			}
+		}
+#endif   /* USE_PREFETCH */
 	}
 	else
 	{
@@ -1065,11 +1121,56 @@ _bt_next(IndexScanDesc scan, ScanDirecti
 			/* We must acquire lock before applying _bt_steppage */
 			Assert(BufferIsValid(so->currPos.buf));
 			LockBuffer(so->currPos.buf, BT_READ);
-			if (!_bt_steppage(scan, dir))
+			if (!_bt_steppage(scan, dir, target_prefetch_pages > 0))
 				return false;
 			/* Drop the lock, but not pin, on the new page */
 			LockBuffer(so->currPos.buf, BUFFER_LOCK_UNLOCK);
 		}
+		
+#ifdef USE_PREFETCH
+                /*    consider prefetching */
+		if (prefetch_btree_heaps && (target_prefetch_pages > 0)) {
+			BlockNumber currblkno = ItemPointerGetBlockNumber(
+				&so->currPos.items[so->currPos.itemIndex].heapTid);
+		
+			if (currblkno != prevblkno) {
+				if (so->prefetchBlockCount > 0)
+					so->prefetchBlockCount--;
+			
+				/* If we have heap fetch frequency stats, and it's above ~94%,
+				 * initiate heap prefetches */
+				if (so->currPos.moreLeft
+					&& scan->heap_tids_seen > 256 
+					&& ( (scan->heap_tids_seen - scan->heap_tids_seen/16)
+						 <= scan->heap_tids_fetched ) )
+				{
+					bool nonsequential = false;
+			
+					if (so->prefetchItemIndex >= so->currPos.itemIndex)
+						so->prefetchItemIndex = so->currPos.itemIndex - 1;
+					while (    (so->prefetchItemIndex >= so->currPos.firstItem)
+							&& (so->prefetchBlockCount < target_prefetch_pages) )
+					{
+						ItemPointer tid = &so->currPos.items[so->prefetchItemIndex--].heapTid;
+						BlockNumber blkno = ItemPointerGetBlockNumber(tid);
+						if (blkno != so->lastHeapPrefetchBlkno) {  /*  if not a repetition of previous block */
+							/*   start prefetch on next page, providing :
+                            **   EITHER  .  we're reading non-sequentially previously or for this block
+                            **   OR      .  user explicitly specified to prefetch for sequential pattern
+							**   as it may be counterproductive otherwise
+                            */
+							nonsequential = (nonsequential || blkno != (so->lastHeapPrefetchBlkno+1));
+							if (prefetch_sequential_index_scans || nonsequential) {
+								_bt_prefetchbuf(scan->heapRelation, blkno , &scan->pfch_index_page_list );
+							}
+							so->lastHeapPrefetchBlkno = blkno;
+							so->prefetchBlockCount++;
+						}
+					}
+				}
+			}
+		}
+#endif   /* USE_PREFETCH */
 	}
 
 	/* OK, itemIndex says what to return */
@@ -1119,9 +1220,11 @@ _bt_readpage(IndexScanDesc scan, ScanDir
 	/*
 	 * we must save the page's right-link while scanning it; this tells us
 	 * where to step right to after we're done with these items.  There is no
-	 * corresponding need for the left-link, since splits always go right.
+	 * corresponding need for the left-link, since splits always go right,
+	 * but we need it for back-sequential scan detection.
 	 */
 	so->currPos.nextPage = opaque->btpo_next;
+	so->currPos.prevPage = opaque->btpo_prev;
 
 	/* initialize tuple workspace to empty */
 	so->currPos.nextTupleOffset = 0;
@@ -1156,6 +1259,7 @@ _bt_readpage(IndexScanDesc scan, ScanDir
 		so->currPos.firstItem = 0;
 		so->currPos.lastItem = itemIndex - 1;
 		so->currPos.itemIndex = 0;
+		so->prefetchItemIndex = 0;
 	}
 	else
 	{
@@ -1187,6 +1291,7 @@ _bt_readpage(IndexScanDesc scan, ScanDir
 		so->currPos.firstItem = itemIndex;
 		so->currPos.lastItem = MaxIndexTuplesPerPage - 1;
 		so->currPos.itemIndex = MaxIndexTuplesPerPage - 1;
+		so->prefetchItemIndex = MaxIndexTuplesPerPage - 1;
 	}
 
 	return (so->currPos.firstItem <= so->currPos.lastItem);
@@ -1224,7 +1329,7 @@ _bt_saveitem(BTScanOpaque so, int itemIn
  * locks and pins, set so->currPos.buf to InvalidBuffer, and return FALSE.
  */
 static bool
-_bt_steppage(IndexScanDesc scan, ScanDirection dir)
+_bt_steppage(IndexScanDesc scan, ScanDirection dir, bool prefetch)
 {
 	BTScanOpaque so = (BTScanOpaque) scan->opaque;
 	Relation	rel;
@@ -1278,7 +1383,11 @@ _bt_steppage(IndexScanDesc scan, ScanDir
 			/* check for interrupts while we're not holding any buffer lock */
 			CHECK_FOR_INTERRUPTS();
 			/* step right one page */
-			so->currPos.buf = _bt_getbuf(rel, blkno, BT_READ);
+			so->currPos.buf = _bt_getbuf(rel, blkno, BT_READ
+#ifdef USE_PREFETCH
+                                     ,scan->pfch_index_page_list
+#endif /* USE_PREFETCH */
+                                                    );
 			/* check for deleted page */
 			page = BufferGetPage(so->currPos.buf);
 			opaque = (BTPageOpaque) PageGetSpecialPointer(page);
@@ -1287,9 +1396,22 @@ _bt_steppage(IndexScanDesc scan, ScanDir
 				PredicateLockPage(rel, blkno, scan->xs_snapshot);
 				/* see if there are any matches on this page */
 				/* note that this will clear moreRight if we can stop */
-				if (_bt_readpage(scan, dir, P_FIRSTDATAKEY(opaque)))
+				if (_bt_readpage(scan, dir, P_FIRSTDATAKEY(opaque))) {
+#ifdef USE_PREFETCH
+					if (    prefetch && so->currPos.moreRight
+						/*   start prefetch on next page, providing :
+						**   EITHER  .  we're reading non-sequentially for this block
+						**   OR      .  user explicitly specified to prefetch for sequential pattern
+						**   as it may be counterproductive otherwise
+						*/
+						&& (prefetch_sequential_index_scans || opaque->btpo_next != (blkno+1))
+                                            ) {
+ 						  _bt_prefetchbuf(rel, opaque->btpo_next , &scan->pfch_index_page_list);
+					}
+#endif /* USE_PREFETCH */
 					break;
 			}
+			}
 			/* nope, keep going */
 			blkno = opaque->btpo_next;
 		}
@@ -1317,7 +1439,7 @@ _bt_steppage(IndexScanDesc scan, ScanDir
 			}
 
 			/* Step to next physical page */
-			so->currPos.buf = _bt_walk_left(rel, so->currPos.buf);
+			so->currPos.buf = _bt_walk_left(scan , rel, so->currPos.buf);
 
 			/* if we're physically at end of index, return failure */
 			if (so->currPos.buf == InvalidBuffer)
@@ -1332,14 +1454,60 @@ _bt_steppage(IndexScanDesc scan, ScanDir
 			opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 			if (!P_IGNORE(opaque))
 			{
+				/* We must rely on the previously saved prevPage link! */
+				BlockNumber blkno = so->currPos.prevPage;
+				
 				PredicateLockPage(rel, BufferGetBlockNumber(so->currPos.buf), scan->xs_snapshot);
 				/* see if there are any matches on this page */
 				/* note that this will clear moreLeft if we can stop */
-				if (_bt_readpage(scan, dir, PageGetMaxOffsetNumber(page)))
+				if (_bt_readpage(scan, dir, PageGetMaxOffsetNumber(page))) {
+#ifdef USE_PREFETCH
+					if (prefetch && so->currPos.moreLeft) {
+						/* detect back-sequential runs and increase prefetch window blindly 
+						 * downwards 2 blocks at a time. This only works in our favor
+						 * for index-only scans, by merging read requests at the kernel,
+						 * so we want to inflate target_prefetch_pages since merged 
+						 * back-sequential requests are about as expensive as a single one 
+						 */
+						if (scan->xs_want_itup && blkno > 0 && opaque->btpo_prev == (blkno-1)) {
+							BlockNumber backPos;
+							unsigned int back_prefetch_pages = target_prefetch_pages * 16;
+							if (back_prefetch_pages > 64)
+								back_prefetch_pages = 64;
+							
+							if (so->backSeqRun == 0)
+								backPos = (blkno-1);
+							else
+								backPos = so->backSeqPos;
+							so->backSeqRun++;
+							
+							if (backPos > 0 && (blkno - backPos) <= back_prefetch_pages) {
+								_bt_prefetchbuf(rel, backPos-- , &scan->pfch_index_page_list);
+								/* don't start back-seq prefetch too early */
+								if (so->backSeqRun >= back_prefetch_pages
+										&& backPos > 0 
+										&& (blkno - backPos) <= back_prefetch_pages)
+								{
+									_bt_prefetchbuf(rel, backPos-- , &scan->pfch_index_page_list);
+								}
+							}
+							
+							so->backSeqPos = backPos;
+						} else {
+							/* start prefetch on next page */
+							if (so->backSeqRun != 0) {
+								if (opaque->btpo_prev > blkno || opaque->btpo_prev < so->backSeqPos)
+									so->backSeqRun = 0;
+							}
+							_bt_prefetchbuf(rel, opaque->btpo_prev , &scan->pfch_index_page_list);
+						}
+					}
+#endif /* USE_PREFETCH */
 					break;
 			}
 		}
 	}
+	}
 
 	return true;
 }
@@ -1359,7 +1527,7 @@ _bt_steppage(IndexScanDesc scan, ScanDir
  * again if it's important.
  */
 static Buffer
-_bt_walk_left(Relation rel, Buffer buf)
+_bt_walk_left(IndexScanDesc scan, Relation rel, Buffer buf)
 {
 	Page		page;
 	BTPageOpaque opaque;
@@ -1387,7 +1555,11 @@ _bt_walk_left(Relation rel, Buffer buf)
 		_bt_relbuf(rel, buf);
 		/* check for interrupts while we're not holding any buffer lock */
 		CHECK_FOR_INTERRUPTS();
-		buf = _bt_getbuf(rel, blkno, BT_READ);
+		buf = _bt_getbuf(rel, blkno, BT_READ
+#ifdef USE_PREFETCH
+                                     , scan->pfch_index_page_list
+#endif /* USE_PREFETCH */
+                                );
 		page = BufferGetPage(buf);
 		opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 
@@ -1631,7 +1803,7 @@ _bt_endpoint(IndexScanDesc scan, ScanDir
 		 * There's no actually-matching data on this page.  Try to advance to
 		 * the next page.  Return false if there's no matching data at all.
 		 */
-		if (!_bt_steppage(scan, dir))
+		if (!_bt_steppage(scan, dir, false))
 			return false;
 	}
 
--- src/backend/access/nbtree/nbtinsert.c.orig	2014-08-18 14:10:36.845016657 -0400
+++ src/backend/access/nbtree/nbtinsert.c	2014-08-19 16:56:13.947198104 -0400
@@ -793,7 +793,11 @@ _bt_insertonpg(Relation rel,
 		{
 			Assert(!P_ISLEAF(lpageop));
 
-			metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE);
+			metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                );
 			metapg = BufferGetPage(metabuf);
 			metad = BTPageGetMeta(metapg);
 
@@ -972,7 +976,11 @@ _bt_split(Relation rel, Buffer buf, Buff
 	bool		isleaf;
 
 	/* Acquire a new page to split into */
-	rbuf = _bt_getbuf(rel, P_NEW, BT_WRITE);
+	rbuf = _bt_getbuf(rel, P_NEW, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                );
 
 	/*
 	 * origpage is the original page to be split.  leftpage is a temporary
@@ -1175,7 +1183,11 @@ _bt_split(Relation rel, Buffer buf, Buff
 
 	if (!P_RIGHTMOST(oopaque))
 	{
-		sbuf = _bt_getbuf(rel, oopaque->btpo_next, BT_WRITE);
+		sbuf = _bt_getbuf(rel, oopaque->btpo_next, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                                );
 		spage = BufferGetPage(sbuf);
 		sopaque = (BTPageOpaque) PageGetSpecialPointer(spage);
 		if (sopaque->btpo_prev != origpagenumber)
@@ -1817,7 +1829,11 @@ _bt_finish_split(Relation rel, Buffer lb
 	Assert(P_INCOMPLETE_SPLIT(lpageop));
 
 	/* Lock right sibling, the one missing the downlink */
-	rbuf = _bt_getbuf(rel, lpageop->btpo_next, BT_WRITE);
+	rbuf = _bt_getbuf(rel, lpageop->btpo_next, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                     );
 	rpage = BufferGetPage(rbuf);
 	rpageop = (BTPageOpaque) PageGetSpecialPointer(rpage);
 
@@ -1829,7 +1845,11 @@ _bt_finish_split(Relation rel, Buffer lb
 		BTMetaPageData *metad;
 
 		/* acquire lock on the metapage */
-		metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE);
+		metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                            );
 		metapg = BufferGetPage(metabuf);
 		metad = BTPageGetMeta(metapg);
 
@@ -1877,7 +1897,11 @@ _bt_getstackbuf(Relation rel, BTStack st
 		Page		page;
 		BTPageOpaque opaque;
 
-		buf = _bt_getbuf(rel, blkno, access);
+		buf = _bt_getbuf(rel, blkno, access
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 		page = BufferGetPage(buf);
 		opaque = (BTPageOpaque) PageGetSpecialPointer(page);
 
@@ -2008,12 +2032,20 @@ _bt_newroot(Relation rel, Buffer lbuf, B
 	lopaque = (BTPageOpaque) PageGetSpecialPointer(lpage);
 
 	/* get a new root page */
-	rootbuf = _bt_getbuf(rel, P_NEW, BT_WRITE);
+	rootbuf = _bt_getbuf(rel, P_NEW, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 	rootpage = BufferGetPage(rootbuf);
 	rootblknum = BufferGetBlockNumber(rootbuf);
 
 	/* acquire lock on the metapage */
-	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE);
+	metabuf = _bt_getbuf(rel, BTREE_METAPAGE, BT_WRITE
+#ifdef USE_PREFETCH
+                                    , (struct pfch_index_pagelist*)0
+#endif /* USE_PREFETCH */
+                        );
 	metapg = BufferGetPage(metabuf);
 	metad = BTPageGetMeta(metapg);
 
